package com.prowidesoftware.brilliance.mx2mt;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.util.StringUtil;
import com.prowidesoftware.swift.model.mx.dic.CashAccount16;
import com.prowidesoftware.swift.model.mx.dic.GenericAccountIdentification1;

import java.util.Map;

public abstract class AbstractMx2MtFieldsGenerate implements Mx2MtFieldsGenerate {

    protected Map<String, Object> map = null;

    protected void withMap(Map<String, Object> targetMap) {
        map = targetMap;
    }

    /**
     * length == 8 append AXXX
     * length == 11 substring(0,8)+A+substring(8)
     * @param bicCode
     * @return
     */
    protected String processBicCode(String bicCode) {
        String processedBicCode = "";
        if (!StringUtil.isEmpty(bicCode)) {
            if (bicCode.length() == 8) {
                processedBicCode = bicCode + Mx2MtConstants.BICSUFFIX;
            } else if (bicCode.length() == 11) {
                processedBicCode = bicCode.substring(0, 8) + Mx2MtConstants.BICMIDDLE + bicCode.substring(8);
            } else {
                throw new SwiftException("ERROR", "BicCode length is invalid.");
            }
        }
        return processedBicCode;
    }

    protected String getMtFormatAccount(CashAccount16 dbtrAcct) {
        String account = "";
        String iban = "";
        String otherId = "";
        if (dbtrAcct != null) {
            if (dbtrAcct.getId() != null) {
                iban = dbtrAcct.getId().getIBAN();
                if (StringUtil.isEmpty(iban)) {
                    GenericAccountIdentification1 othr = dbtrAcct.getId().getOthr();
                    if (othr != null) {
                        if (othr.getSchmeNm() != null) {
                            otherId = othr.getSchmeNm().getCd();
                        }
                        if (StringUtil.isEmpty(otherId)) {
                            otherId = othr.getId();
                        }
                    }
                }
            }
        }
        if (!StringUtil.isEmpty(iban)) {
            account = "/"+iban;
        } else if (!StringUtil.isEmpty(otherId)) {
            account = "//CH"+otherId;
        }
        return account;
    }
}
