package com.prowidesoftware.brilliance.mx2mt.mt103;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtCreator;
import com.prowidesoftware.brilliance.mx2mt.Mx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.mx2mt.mt103.impl.*;
import com.prowidesoftware.brilliance.util.TemplateUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class Mx2Mt103Creator extends AbstractMx2MtCreator {
    private static final Logger logger = LoggerFactory.getLogger(Mx2Mt103Creator.class);
    /**
     * Object  MxPacs00800102
     * receiverBic
     * senderBic
     * field20
     * field13C
     * field23B
     * field23E
     * field26T
     * field32A
     * field33B
     * field36
     * field50A
     * field50F
     * field50K
     * field51A
     * field52A
     * field52D
     * field53A
     * field53B
     * field53D
     * field54A
     * field54D
     * field55A
     * field55D
     * field56A
     * field56C
     * field56D
     * field57A
     * field57C
     * field57D
     * field59
     * field59A
     * field70
     * field71A
     * field71F
     * field71G
     * field72
     * field77B
     * @return
     */
    @Override
    public List<Mx2MtFieldsGenerate> getFieldsGenerateList() {
        List<Mx2MtFieldsGenerate> fieldsGenerateList = new ArrayList<>();
        fieldsGenerateList.add(new ReceiverBicFieldGenerate());
        fieldsGenerateList.add(new SenderBicFieldGenerate());
        fieldsGenerateList.add(new Field13CGenerate());
        fieldsGenerateList.add(new Field20Generate());
        fieldsGenerateList.add(new Field23BGenerate());
        fieldsGenerateList.add(new Field23EGenerate());
        fieldsGenerateList.add(new Field26TGenerate());
        fieldsGenerateList.add(new Field32AGenerate());
        fieldsGenerateList.add(new Field33BGenerate());
        fieldsGenerateList.add(new Field36Generate());
        fieldsGenerateList.add(new Field50AGenerate());
        fieldsGenerateList.add(new Field52AGenerate());
        fieldsGenerateList.add(new Field53AGenerate());
        fieldsGenerateList.add(new Field54AGenerate());
        fieldsGenerateList.add(new Field55AGenerate());
        fieldsGenerateList.add(new Field56AGenerate());
        fieldsGenerateList.add(new Field57AGenerate());
        fieldsGenerateList.add(new Field59Generate());
        fieldsGenerateList.add(new Field70Generate());
        fieldsGenerateList.add(new Field71AGenerate());
        fieldsGenerateList.add(new Field72Generate());
        fieldsGenerateList.add(new Field77BGenerate());
        fieldsGenerateList.add(new CommonFieldFor103Generate());
        return fieldsGenerateList;
    }

    @Override
    public String generateMtMsg() {
        map.forEach((key,value)->{
            if (!Mx2MtConstants.MX_OBJECT.equals(key)) {
                logger.info(key + "-" + value);
            }
        });
        String outPutFilePath = (String)map.get(Mx2MtConstants.OUT_PUT_FILE_PATH);
        String msg = TemplateUtil.makeFileByTemplate("swift_mt_103.vm", map, outPutFilePath, "utf-8");
        return msg;
    }

    @Override
    protected String getMtType() {
        return Mx2MtConstants.MT_TYPE_103;
    }
}
