package com.prowidesoftware.brilliance.mx2mt.mt103.impl;


import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;

import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.util.DateUtil;
import com.prowidesoftware.swift.model.mx.MxPacs00800102;
import com.prowidesoftware.swift.model.mx.dic.FIToFICustomerCreditTransferV02;
import com.prowidesoftware.swift.model.mx.dic.GroupHeader33;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CommonFieldFor103Generate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(CommonFieldFor103Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        logger.info("CommonFieldFor103Generate start.");
        try {
            MxPacs00800102 mxPacs00800102 =  (MxPacs00800102)map.get(Mx2MtConstants.MX_OBJECT);
            if (mxPacs00800102 == null || mxPacs00800102.getFIToFICstmrCdtTrf() == null) {
                return;
            }
            FIToFICustomerCreditTransferV02 fiToFICstmrCdtTrf = mxPacs00800102.getFIToFICstmrCdtTrf();
            GroupHeader33 grpHdr = fiToFICstmrCdtTrf.getGrpHdr();
            String createDateStr = DateUtil.format(grpHdr.getCreDtTm(), "YYMMdd");
            String createTimeStr = DateUtil.format(grpHdr.getCreDtTm(), "HHmm");
            map.put("createDate", createDateStr);
            map.put("createTime", createTimeStr);
            String outDateStr = DateUtil.formatNow( "YYMMdd");
            String outTimeStr = DateUtil.formatNow("HHmm");
            map.put("outDate", outDateStr);
            map.put("outTime", outTimeStr);
        } catch(Exception e) {
            logger.error(e.getMessage());
            throw new SwiftException("ERROR", "Convert MT103 CommonField error");
        }
    }
}
