package com.prowidesoftware.brilliance.mx2mt.mt103.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.swift.model.mx.MxPacs00800102;
import com.prowidesoftware.swift.model.mx.dic.CreditTransferTransactionInformation11;
import com.prowidesoftware.swift.model.mx.dic.FIToFICustomerCreditTransferV02;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * //1,若节点<BICFI>有值，则设置56 option为“A”，同时BIC取此栏位；
 *         //2,若节点<IBAN>有值，则作为56A的账号；
 *         //3,若节点<Othr><Id>有值，则作为56A的账号；
 *         //<CdtTrfTxInf>[1]<IntrmyAgt1><FinInstnId><BICFI>
 *         //<CdtTrfTxInf>[1]<IntrmyAgt1Acct><Id><IBAN>
 *         //<CdtTrfTxInf>[1]<IntrmyAgt1Acct><Id><Othr><Id>
 *         //<CdtTrfTxInf>[1]<IntrmyAgt1Acct><Id><Othr><SchmeNm><Cd>
 *              //如果<IntrmyAgt1><FinInstnId><BICFI>为空，且<IntrmyAgt1><FinInstnId><Nm>为空，
 *  *         //但节点<IBAN>有值，或者节点<Othr><Id>有值，则设置56option为“C”
 *  *         //若节点<Id><Othr><Id>不为空，则取“//CH”+此节点作为账号，否则取节点<MmbId>作为账号：
 *  *         //<CdtTrfTxInf>[1]<IntrmyAgt1><FinInstnId><ClrSysMmbId><ClrSysId><Cd>
 *  *         //<CdtTrfTxInf>[1]<IntrmyAgt1><FinInstnId><ClrSysMmbId><ClrSysId><Prtry>
 *  *         //<CdtTrfTxInf>[1]<IntrmyAgt1><FinInstnId><ClrSysMmbId><MmbId>
 *  *         //<CdtTrfTxInf>[1]<IntrmyAgt1Acct><Id><Othr><Id>
 *       *         //1，若节点<Nm>有值，则设置56 option为“D”，且名称取自此节点，而地址需要合并截取？？？
 *  *         //2，账号取值规则和节点与56A相同
 *  *         //<CdtTrfTxInf>[1]<IntrmyAgt1><FinInstnId><Nm>
 *  *         //<CdtTrfTxInf>[1]<IntrmyAgt1><FinInstnId><PstlAdr><AdrLine>[1],<AdrLine>[2],<AdrLine>[3]
 */
public class Field56AGenerate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt103.impl.Field56AGenerate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        logger.info("Field56AGenerate start.");
        try {
            MxPacs00800102 obj =  (MxPacs00800102)map.get(Mx2MtConstants.MX_OBJECT);
            if (obj == null || obj.getFIToFICstmrCdtTrf() == null) {
                return;
            }
            FIToFICustomerCreditTransferV02 fiToFICstmrCdtTrf = obj.getFIToFICstmrCdtTrf();
            List<CreditTransferTransactionInformation11> cdtTrfTxInf = fiToFICstmrCdtTrf.getCdtTrfTxInf();
            if (cdtTrfTxInf != null && cdtTrfTxInf.size() > 0){
                if (cdtTrfTxInf.get(0) != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1() != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId() != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getBIC() != null){
                    map.put("field56Key","A");
                    map.put("field56A",cdtTrfTxInf.get(0).getDbtrAgt().getFinInstnId().getBIC());
                    if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct() != null
                            && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId() != null){
                        if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getIBAN() != null){
                            map.put("field56Account",cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getIBAN());
                        }else if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr() != null
                                && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId() != null){
                            map.put("field56Account",cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId());
                        }
                    }
                }else if (cdtTrfTxInf.get(0) != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1() != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId() != null){
                    if (cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getBIC() == null
                            && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getNm() == null){
                        if ((cdtTrfTxInf.get(0).getIntrmyAgt1Acct() != null
                                && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId() != null
                                && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getIBAN() != null)
                                || (cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId() != null
                                && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr() != null
                                && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId() != null)){
                            map.put("field56Key","C");
                            if(cdtTrfTxInf.get(0) != null
                                    && cdtTrfTxInf.get(0).getIntrmyAgt1() != null){
                                if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId() != null
                                        && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr() != null
                                        && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId() != null) {
                                    map.put("field56Account", "//CH" + cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId());
                                }else if (cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId() != null
                                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getClrSysMmbId() != null
                                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getClrSysMmbId().getMmbId() != null){
                                    map.put("field56Account",cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getClrSysMmbId().getMmbId());
                                }
                            }
                        }
                    }
                }else if (cdtTrfTxInf.get(0) != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1() != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId() != null
                        && cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getNm() != null){
                    map.put("field56Key","D");
                    List<String> adrList = cdtTrfTxInf.get(0).getIntrmyAgt1().getFinInstnId().getPstlAdr().getAdrLine();
                    String adStr = "";
                    for (int i = 0; i<adrList.size(); i++){
                        adStr = adStr + adrList.get(i);
                    }
                    map.put("field56DAdr",adStr);
                    if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct() != null
                            && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId() != null){
                        if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getIBAN() != null){
                            map.put("field56Account",cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getIBAN());
                        }else if (cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr() != null
                                && cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId() != null){
                            map.put("field56Account",cdtTrfTxInf.get(0).getIntrmyAgt1Acct().getId().getOthr().getId());
                        }
                    }
                }
            }
        } catch(Exception e) {
            logger.error(e.getMessage());
            throw new SwiftException("ERROR", "Convert MT103 Field56A error");
        }

    }
}
