package com.prowidesoftware.brilliance.mx2mt.mt103.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.swift.model.mx.MxPacs00800102;
import com.prowidesoftware.swift.model.mx.dic.CreditTransferTransactionInformation11;
import com.prowidesoftware.swift.model.mx.dic.FIToFICustomerCreditTransferV02;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 *
 * "1，若节点<Nm>有值，则设置59 option为“”，且名称取自此节点，而地址需要合并截取？？？
 * 2，若节点<IBAN>有值，则在此节点的值前面加上“/”后，作为59账号的值；
 * 3，若节点<Othr><Id>有值，且节点<Othr><SchmeNm><Cd>有值，则在节点<Othr><Id>的值前面加上“//CH”后，作为59账号的值；
 * 4，若节点<Othr><Id>有值，且节点<Othr><SchmeNm><Cd>没值，则在节点<Othr><Id>的值前面加上“/”后，作为59账号的值；"	"<CdtTrfTxInf>[1]<Cdtr><Nm>
 * <CdtTrfTxInf>[1]<Cdtr><PstlAdr><AdrLine>[1]，<AdrLine>[2]，<AdrLine>[3]
 * <CdtTrfTxInf>[1]<CdtrAcct><Id><IBAN>
 * <CdtTrfTxInf>[1]<CdtrAcct><Id><Othr><Id>
 * <CdtTrfTxInf>[1]<CdtrAcct><Id><Othr><SchmeNm><Cd>"
 *  * 1，若节点<AnyBIC>有值，则设置59 option为“A”，同时BIC取此栏位；
 *  * 2，账号取值规则和节点与59相同
 *  * <CdtTrfTxInf>[1]<Cdtr><Id><OrgId><AnyBIC>
 * **/
public class Field59Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt103.impl.Field59Generate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        logger.info("Field59Generate start.");
        try {
            MxPacs00800102 obj =  (MxPacs00800102)map.get(Mx2MtConstants.MX_OBJECT);
            if (obj == null || obj.getFIToFICstmrCdtTrf() == null) {
                return;
            }
            FIToFICustomerCreditTransferV02 fiToFICstmrCdtTrf = obj.getFIToFICstmrCdtTrf();
            List<CreditTransferTransactionInformation11> cdtTrfTxInf = fiToFICstmrCdtTrf.getCdtTrfTxInf();
            if (cdtTrfTxInf != null && cdtTrfTxInf.size() > 0){
                if (cdtTrfTxInf.get(0) != null
                        && cdtTrfTxInf.get(0).getCdtr() != null
                        && cdtTrfTxInf.get(0).getCdtr().getNm() != null){
                    map.put("field59Key","");
                    List<String> adrList = cdtTrfTxInf.get(0).getCdtr().getPstlAdr().getAdrLine();
                    String adStr = "";
                    for (int i = 0; i<adrList.size(); i++){
                        adStr = adStr + adrList.get(i);
                    }
                    map.put("field59Adr",adStr);
                }else if (cdtTrfTxInf.get(0) != null
                        && cdtTrfTxInf.get(0).getCdtr() != null
                        && cdtTrfTxInf.get(0).getCdtr().getId() != null
                        && cdtTrfTxInf.get(0).getCdtr().getId().getOrgId() != null
                        && cdtTrfTxInf.get(0).getCdtr().getId().getOrgId().getBICOrBEI() != null){
                    map.put("field59AKey","A");
                }
                if (cdtTrfTxInf.get(0).getCdtrAcct() != null
                        && cdtTrfTxInf.get(0).getCdtrAcct().getId() != null){
                    if (cdtTrfTxInf.get(0).getCdtrAcct().getId().getIBAN() != null){
                        map.put("field59Account","/" + cdtTrfTxInf.get(0).getCdtrAcct().getId().getIBAN());
                    }else if ((cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr() != null
                            && cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getId() != null)
                            &&
                            (cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr() != null
                                    && cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getSchmeNm() != null
                                    && cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getSchmeNm().getCd() != null)){
                        map.put("field59Account","//CH" + cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getId());
                    }else if (cdtTrfTxInf.get(0).getCdtrAcct() != null
                            && cdtTrfTxInf.get(0).getCdtrAcct().getId() != null){
                        if ((cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr() != null
                                && cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getId() != null)
                                &&
                                (cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr() != null
                                        && cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getSchmeNm() != null
                                        && cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getSchmeNm().getCd() == null)){
                            map.put("field59Account","/" + cdtTrfTxInf.get(0).getCdtrAcct().getId().getOthr().getId());
                        }
                    }
                }
            }
        } catch(Exception e) {
            logger.error(e.getMessage());
            throw new SwiftException("ERROR", "Convert MT103 Field59 error");
        }

    }
}
