package com.prowidesoftware.brilliance.mx2mt.mt103.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.swift.model.mx.MxPacs00800102;
import com.prowidesoftware.swift.model.mx.dic.CreditTransferTransactionInformation11;
import com.prowidesoftware.swift.model.mx.dic.FIToFICustomerCreditTransferV02;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * // 1，取<RgltryRptg>[1]<Dtls>[1]<Inf>[1]作为第一行信息
 *         //2，取<RgltryRptg>[2]<Dtls>[1]<Inf>[1]作为第二行信息
 *         //3，取<RgltryRptg>[3]<Dtls>[1]<Inf>[1]作为第二行信息
 *         //<CdtTrfTxInf>[1]<RgltryRptg>[1]<Dtls>[1]<Inf>[1]
 */
public class Field77BGenerate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt103.impl.Field77BGenerate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        logger.info("Field77BGenerate start.");
        try {
            MxPacs00800102 obj =  (MxPacs00800102)map.get(Mx2MtConstants.MX_OBJECT);
            if (obj == null || obj.getFIToFICstmrCdtTrf() == null) {
                return;
            }
            FIToFICustomerCreditTransferV02 fiToFICstmrCdtTrf = obj.getFIToFICstmrCdtTrf();
            List<CreditTransferTransactionInformation11> cdtTrfTxInf = fiToFICstmrCdtTrf.getCdtTrfTxInf();
            if (cdtTrfTxInf != null && cdtTrfTxInf.size() > 0){
                if (cdtTrfTxInf.get(0) != null
                        && cdtTrfTxInf.get(0).getRgltryRptg().size() > 0){
                    if (cdtTrfTxInf.get(0).getRgltryRptg().get(0) != null
                            && cdtTrfTxInf.get(0).getRgltryRptg().get(0).getDtls().size() > 0
                            && cdtTrfTxInf.get(0).getRgltryRptg().get(0).getDtls().get(0).getInf().size() > 0
                            && cdtTrfTxInf.get(0).getRgltryRptg().get(0).getDtls().get(0).getInf().get(0) != null) {
                        if (cdtTrfTxInf.get(0).getRgltryRptg().get(1) != null
                                && cdtTrfTxInf.get(0).getRgltryRptg().get(1).getDtls().size() >0
                                && cdtTrfTxInf.get(0).getRgltryRptg().get(1).getDtls().get(0) != null
                                && cdtTrfTxInf.get(0).getRgltryRptg().get(1).getDtls().get(0).getInf().size() > 0
                                && cdtTrfTxInf.get(0).getRgltryRptg().get(1).getDtls().get(0).getInf().get(0) != null){
                            if (cdtTrfTxInf.get(0).getRgltryRptg().get(2) != null
                                    && cdtTrfTxInf.get(0).getRgltryRptg().get(2).getDtls().size() > 0
                                    && cdtTrfTxInf.get(0).getRgltryRptg().get(2).getDtls().get(0) != null
                                    && cdtTrfTxInf.get(0).getRgltryRptg().get(2).getDtls().get(0).getInf().size() > 0
                                    && cdtTrfTxInf.get(0).getRgltryRptg().get(2).getDtls().get(0).getInf().get(0) != null){
                                map.put("field77B",cdtTrfTxInf.get(0).getRgltryRptg().get(0).getDtls().get(0).getInf().get(0)
                                        + Mx2MtConstants.NEW_LINE + cdtTrfTxInf.get(0).getRgltryRptg().get(1).getDtls().get(0).getInf().get(0)
                                        + Mx2MtConstants.NEW_LINE + cdtTrfTxInf.get(0).getRgltryRptg().get(2).getDtls().get(0).getInf().get(0));
                            }
                        }
                    }
                }
            }
        } catch(Exception e) {
            logger.error(e.getMessage());
            throw new SwiftException("ERROR", "Convert MT103 Field77B error");
        }

    }
}

