package com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.swift.model.mx.MxPacs00900102;
import com.prowidesoftware.swift.model.mx.dic.FinancialInstitutionCreditTransferV02;
import com.prowidesoftware.swift.model.mx.dic.GroupHeader35;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * <GrpHdr><MsgId>
 */
public class Field20Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl.Field20Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            MxPacs00900102 obj =  (MxPacs00900102)map.get(Mx2MtConstants.MX_OBJECT);
            if (obj == null || obj.getFinInstnCdtTrf() == null) {
                return;
            }
            FinancialInstitutionCreditTransferV02 finInstnCdtTrf = obj.getFinInstnCdtTrf();
            GroupHeader35 grpHdr = finInstnCdtTrf.getGrpHdr();
            map.put("field20", grpHdr.getMsgId());
        } catch(Exception e) {
            throw new SwiftException("ERROR", "Convert MT202 Field20 error");
        }

    }
}
