package com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl;

import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.swift.model.mx.MxPacs00900102;
import com.prowidesoftware.swift.model.mx.dic.FinancialInstitutionCreditTransferV02;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * <CdtTrfTxInf>[1]<PmtId><EndToEndId>
 */
public class Field21Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl.Field21Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field21 = "NONREF";
            MxPacs00900102 obj =  (MxPacs00900102)map.get("mxObj");
            if (obj == null || obj.getFinInstnCdtTrf() == null) {
                return;
            }
            FinancialInstitutionCreditTransferV02 finInstnCdtTrf = obj.getFinInstnCdtTrf();
            if (finInstnCdtTrf.getCdtTrfTxInf() != null && finInstnCdtTrf.getCdtTrfTxInf().size() > 0) {
                if (finInstnCdtTrf.getCdtTrfTxInf().get(0) != null
                    && finInstnCdtTrf.getCdtTrfTxInf().get(0).getPmtId() != null
                    && finInstnCdtTrf.getCdtTrfTxInf().get(0).getPmtId().getEndToEndId() != null){
                    field21 = finInstnCdtTrf.getCdtTrfTxInf().get(0).getPmtId().getEndToEndId();
                }
            }
            map.put("field21", field21);
        } catch(Exception e) {
            throw new SwiftException("ERROR", "Convert MT202 Field21 error");
        }

    }
}
