package com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl.cov;

import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.util.NumberUtil;
import com.prowidesoftware.swift.model.mx.MxPacs00900102;
import com.prowidesoftware.swift.model.mx.dic.CreditTransferTransactionInformation13;
import com.prowidesoftware.swift.model.mx.dic.FinancialInstitutionCreditTransferV02;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.util.List;

/**
 * 直接取此节点作为33B的货币和金额，XXX是货币
 * <CdtTrfTxInf>[1]<UndrlygCstmrCdtTrf><InstdAmt Ccy="xxx">
 */
public class FieldB33BGenerate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl.cov.FieldB33BGenerate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            MxPacs00900102 obj =  (MxPacs00900102)map.get("mxObj");
            if (obj == null || obj.getFinInstnCdtTrf() == null) {
                return;
            }
            String filed33B = "";
            FinancialInstitutionCreditTransferV02 finInstnCdtTrf = obj.getFinInstnCdtTrf();
            List<CreditTransferTransactionInformation13> cdtTrfTxInf = finInstnCdtTrf.getCdtTrfTxInf();
            if (cdtTrfTxInf != null && cdtTrfTxInf.size() > 0
                    && cdtTrfTxInf.get(0) != null
                    && cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf() != null){
                if (cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getInstdAmt() != null
                        && cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getInstdAmt().getCcy() != null){
                    String ccy = cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getInstdAmt().getCcy();
                    BigDecimal amt = cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getInstdAmt().getValue();
                    String amtStr = NumberUtil.formatAmt(amt, ccy);
                    filed33B = ccy+amtStr;
                }
            }
            map.put("field33B", filed33B);
        } catch(Exception e) {
            throw new SwiftException("ERROR", "Convert MT202COV Field33B error");
        }
    }
}

