package com.prowidesoftware.brilliance.mx2mt.mt202cov202.impl.cov;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.util.StringUtil;
import com.prowidesoftware.swift.model.mx.MxPacs00900102;
import com.prowidesoftware.swift.model.mx.dic.CreditTransferTransactionInformation13;
import com.prowidesoftware.swift.model.mx.dic.FinancialInstitutionCreditTransferV02;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * 取此节点按4*35的格式拆分，放入70栏位中(最多4行每行最多35个字符)
 * <CdtTrfTxInf>[1]<UndrlygCstmrCdtTrf><RmtInf><Ustrd>[1]
 */
public class FieldB70Generate extends AbstractMx2MtFieldsGenerate {

    private static final Logger logger = LoggerFactory.getLogger(FieldB70Generate.class);

    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            MxPacs00900102 obj =  (MxPacs00900102)map.get(Mx2MtConstants.MX_OBJECT);
            if (obj == null || obj.getFinInstnCdtTrf() == null) {
                return;
            }
            String field70B = "";
            FinancialInstitutionCreditTransferV02 finInstnCdtTrf = obj.getFinInstnCdtTrf();
            List<CreditTransferTransactionInformation13> cdtTrfTxInf = finInstnCdtTrf.getCdtTrfTxInf();
            if (cdtTrfTxInf != null && cdtTrfTxInf.size() > 0
                    && cdtTrfTxInf.get(0) != null
                    && cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf() != null){
                if (cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getRmtInf() != null
                        && cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getRmtInf().getUstrd() != null
                        && cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getRmtInf().getUstrd().size() >0
                        && cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getRmtInf().getUstrd().get(0) != null){
                    String s = cdtTrfTxInf.get(0).getUndrlygCstmrCdtTrf().getRmtInf().getUstrd().get(0);
                    field70B = StringUtil.getStringByEnter(s, 35, 4);
                }
            }
            map.put("field70B", field70B);
        } catch(Exception e) {
            throw new SwiftException("ERROR", "Convert MT202COV Field70 error");
        }

    }
}
